package com.example.aped.ui.all_IOs;


import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import androidx.fragment.app.Fragment;
import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Dictionary;
import java.util.List;


public class AllIOsFragment extends Fragment {
    /**
     * Einbinden der MainActivity.
     */
    private MainActivity mainActivity;
    /**
     * Genutzt für Signallampe.
     */
    private int image;
    /**
     * Genutzt für Favoriten icons.
     */
    private int favoriteImage;

    /**
     * @param inflater
     * @param container
     * @param savedInstanceState
     * @return view
     */
    @Override
    public View onCreateView(final LayoutInflater inflater,
                             final ViewGroup container,
                             final Bundle savedInstanceState) {
        this.mainActivity = (MainActivity) getActivity();
        View view = inflater.inflate(R.layout.fragment_all_ios, container,
                false);
        ListView lv = (ListView) view.findViewById(R.id.idListView);
        CustomAdapter customAdapter = new CustomAdapter();
        lv.setAdapter(customAdapter);
        return view;
    }

        class CustomAdapter extends BaseAdapter {

            @Override
            public int getCount() {
                return mainActivity.xml.getDeviceNames().size();
            }

            @Override
            public Object getItem(final int position) {

                return null;
            }

            @Override
            public long getItemId(final int position) {

                return 0;
            }

            @Override
            public View getView(final int i, View view,
                                final ViewGroup viewGroup) {
                /*if(mainActivity.uebergabe.read(mainActivity.xml.
                getDeviceNames().get(i)).equals("TRUE")) {
                    image=R.drawable.green_signal;
                }else if (mainActivity.uebergabe.read(mainActivity.xml.
                getDeviceNames().get(i)).equals("FALSE")) {
                    image = R.drawable.red_signal;
                }
                else{*/
                    image = R.drawable.off_signal;
                //}
                if (mainActivity.favorite.getFavorites().contains(
                        mainActivity.xml.getDeviceNames().get(i))) {
                    favoriteImage = android.R.drawable.btn_star_big_on;
                } else {
                    favoriteImage = android.R.drawable.btn_star_big_off;
                }
                view = getLayoutInflater().inflate(R.layout.listview_layout,
                        null);
                ImageView imageView = (ImageView) view.findViewById(
                        R.id.images);
                TextView textViewName = (TextView) view.findViewById(
                        R.id.textName);
                TextView textViewState = (TextView) view.findViewById(
                        R.id.textState);
                ImageView buttonViewFavoriten = (ImageView) view.findViewById(
                        R.id.imageButtonFavoriten);
                buttonViewFavoriten.setOnClickListener(
                        new View.OnClickListener() {
                    @Override
                            public void onClick(final View view) {
                        if (mainActivity.favorite.getFavorites().contains(
                                mainActivity.xml.getDeviceNames().get(i))) {
                            mainActivity.favorite.removeFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_off;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        } else {
                            mainActivity.favorite.addFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_on;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        }
                    }
                });

                /**
                 * Verarbeitung/ Änderung der Zustände DO
                 */
                imageView.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(final View view) {
                        Toast.makeText(getContext(), "Click auf: " + i,
                                Toast.LENGTH_SHORT).show();
                    }
                });


                imageView.setImageResource(image);
                textViewName.setText(mainActivity.xml.getDeviceNames().get(i));
                //TextView_State.setText(mainActivity.uebergabe.read(
                // mainActivity.xml.getDeviceNames().get(i)));
                mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().
                        get(i), new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(final JSONObject response) {
                        try {
                            JSONObject pins = response.getJSONObject("state");
                            String devicename   = mainActivity.xml.getDeviceNames().get(i);
                            Dictionary<String,Object> portinfo = mainActivity.xml.getPort(devicename);
                            List<String> pinnames = (List<String>) portinfo.get("pins");
                            String firstpinname = pinnames.get(0);
                            int groesse = pinnames.size();
                           /** for(String pinname : pinnames){

                            }//anstatt for mit laufvariable
                            for(int h; h < pinnames.size();h++){
                                String pinname = pinnames.get(h);
                            }*/
                            String firstpinvalue = pins.getString(firstpinname);
                            textViewState.setText(firstpinvalue);
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                });
                buttonViewFavoriten.setImageResource(favoriteImage);
                return view;
            }
        }
    }
